<?php
/**
 * @author Amasty Team
 * @copyright Copyright (c) Amasty (https://www.amasty.com)
 * @package Seo Rich Data Hyva Compatibility
 */

namespace Amasty\SeoRichDataHyva\Plugin\Microdata;

use Hyva\Theme\Service\CurrentTheme;
use Magento\Catalog\Block\Product\View\Description;
use Magento\Framework\Pricing\Render\Amount;
use Magento\Review\Block\Product\ReviewRenderer;
use Magento\Theme\Block\Html\Title;

class Replacer
{
    /**
     * @var CurrentTheme
     */
    private CurrentTheme $currentTheme;

    public function __construct(
        CurrentTheme $currentTheme
    ) {
        $this->currentTheme = $currentTheme;
    }

    /**
     * @param ReviewRenderer|Amount|Title|Description $subject
     * @param string $result
     *
     * @return string
     * @SuppressWarnings(PHPMD.UnusedFormalParameter)
     */
    public function afterToHtml(
        $subject,
        $result
    ) {
        if (!$this->currentTheme->isHyva()) {
            return $result;
        }

        $result = preg_replace('|<meta.*itemprop.*>|U', '', $result);
        $result = preg_replace('|itemprop=".*"|U', '', $result);
        $result = preg_replace('|itemtype=".*"|U', '', $result);
        $result = str_replace('itemscope', '', $result);

        return $result;
    }
}
